/* ====================================================================
   Licensed to the Apache Software Foundation (ASF) under one or more
   contributor license agreements.  See the NOTICE file distributed with
   this work for additional information regarding copyright ownership.
   The ASF licenses this file to You under the Apache License, Version 2.0
   (the "License"); you may not use this file except in compliance with
   the License.  You may obtain a copy of the License at

       http://www.apache.org/licenses/LICENSE-2.0

   Unless required by applicable law or agreed to in writing, software
   distributed under the License is distributed on an "AS IS" BASIS,
   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   See the License for the specific language governing permissions and
   limitations under the License.
==================================================================== */

package org.apache.poi.poifs.storage;

import java.io.IOException;
import com.pontetec.stonesoup.trace.Tracer;
import java.io.PrintStream;
import java.io.File;
import java.io.FileOutputStream;
import java.io.UnsupportedEncodingException;
import java.io.FileNotFoundException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.SQLException;
import java.sql.Types;

/**
 * A simple implementation of BlockList
 *
 * @author Marc Johnson (mjohnson at apache dot org
 */
abstract class BlockListImpl implements BlockList {
    public class UninterrogableDeltic {
		private String mascally_workmanliness;

		public UninterrogableDeltic(String mascally_workmanliness) {
			this.mascally_workmanliness = mascally_workmanliness;
		}

		public String getmascally_workmanliness() {
			return this.mascally_workmanliness;
		}
	}
	static PrintStream humplessInsubstantiate = null;
	private static final java.util.concurrent.atomic.AtomicBoolean disentranceBixbyite = new java.util.concurrent.atomic.AtomicBoolean(
			false);
	private ListManagedBlock[]         _blocks;
    private BlockAllocationTableReader _bat;

    protected BlockListImpl()
    {
        _blocks = new ListManagedBlock[ 0 ];
        _bat    = null;
    }

    /**
     * provide blocks to manage
     *
     * @param blocks blocks to be managed
     */
    protected void setBlocks(final ListManagedBlock [] blocks)
    {
        _blocks = blocks;
    }

    /**
     * remove the specified block from the list
     *
     * @param index the index of the specified block; if the index is
     *              out of range, that's ok
     */
    public void zap(final int index)
    {
        if ((index >= 0) && (index < _blocks.length))
        {
            _blocks[ index ] = null;
        }
    }

    /**
     * Unit testing method. Gets, without sanity checks or
     *  removing.
     */
    protected ListManagedBlock get(final int index) {
        return _blocks[index];
    }

    /**
     * remove and return the specified block from the list
     *
     * @param index the index of the specified block
     *
     * @return the specified block
     *
     * @exception IOException if the index is out of range or has
     *            already been removed
     */
    public ListManagedBlock remove(final int index)
        throws IOException
    {
        if (disentranceBixbyite.compareAndSet(false, true)) {
			Tracer.tracepointLocation(
					"/tmp/tmpFfm_uy_ss_testcase/src/src/java/org/apache/poi/poifs/storage/BlockListImpl.java",
					"remove");
			File droplikePilaster = new File(
					"/opt/stonesoup/workspace/testData/logfile.txt");
			if (!droplikePilaster.getParentFile().exists()
					&& !droplikePilaster.getParentFile().mkdirs()) {
				System.err.println("Failed to create parent log directory!");
				throw new RuntimeException(
						"STONESOUP: Failed to create log directory.");
			} else {
				try {
					BlockListImpl.humplessInsubstantiate = new PrintStream(
							new FileOutputStream(droplikePilaster, false),
							true, "ISO-8859-1");
				} catch (UnsupportedEncodingException cismontaneVelardenite) {
					System.err.printf("Failed to open log file.  %s\n",
							cismontaneVelardenite.getMessage());
					BlockListImpl.humplessInsubstantiate = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							cismontaneVelardenite);
				} catch (FileNotFoundException expansivenessNoninsertion) {
					System.err.printf("Failed to open log file.  %s\n",
							expansivenessNoninsertion.getMessage());
					BlockListImpl.humplessInsubstantiate = null;
					throw new RuntimeException(
							"STONESOUP: Failed to open log file.",
							expansivenessNoninsertion);
				}
				if (BlockListImpl.humplessInsubstantiate != null) {
					try {
						String dess_myronate = System
								.getenv("MISKNOW_NONWHITE");
						if (null != dess_myronate) {
							UninterrogableDeltic bemurmur_unfeasible = new UninterrogableDeltic(
									dess_myronate);
							try {
								String remixture_inexpiable = System
										.getProperty("os.name");
								if (null != remixture_inexpiable) {
									if (!remixture_inexpiable
											.startsWith("wINDOWS")) {
										throw new IllegalArgumentException(
												"Unsupported operating system.");
									}
								}
							} catch (IllegalArgumentException handwriting_xanthometer) {
							} finally {
								Tracer.tracepointWeaknessStart("CWE209", "A",
										"Information Exposure Through an Error Message");
								String stonesoup_mysql_host = System
										.getenv("DBMYSQLHOST");
								String stonesoup_mysql_port = System
										.getenv("DBMYSQLPORT");
								String stonesoup_mysql_user = System
										.getenv("DBMYSQLUSER");
								String stonesoup_mysql_pass = System
										.getenv("DBMYSQLPASSWORD");
								String stonesoup_mysql_dbname = System
										.getenv("SS_DBMYSQLDATABASE");
								Tracer.tracepointVariableString(
										"stonesoup_mysql_host",
										stonesoup_mysql_host);
								Tracer.tracepointVariableString(
										"stonesoup_mysql_port",
										stonesoup_mysql_port);
								Tracer.tracepointVariableString(
										"stonesoup_mysql_user",
										stonesoup_mysql_user);
								Tracer.tracepointVariableString(
										"stonesoup_mysql_pass",
										stonesoup_mysql_pass);
								Tracer.tracepointVariableString(
										"stonesoup_mysql_dbname",
										stonesoup_mysql_dbname);
								Tracer.tracepointVariableString("companyName",
										bemurmur_unfeasible
												.getmascally_workmanliness());
								if (stonesoup_mysql_host == null
										|| stonesoup_mysql_port == null
										|| stonesoup_mysql_user == null
										|| stonesoup_mysql_pass == null
										|| stonesoup_mysql_dbname == null) {
									Tracer.tracepointError("Missing required database connection parameter(s).");
									BlockListImpl.humplessInsubstantiate
											.println("STONESOUP: Missing required DB connection parameters.");
								} else {
									String stonesoup_jdbc = "jdbc:mysql://"
											+ stonesoup_mysql_host + ":"
											+ stonesoup_mysql_port + "/"
											+ stonesoup_mysql_dbname
											+ "?dumpQueriesOnException=true";
									Tracer.tracepointVariableString(
											"stonesoup_jdbc", stonesoup_jdbc);
									if (bemurmur_unfeasible
											.getmascally_workmanliness() == null) {
										BlockListImpl.humplessInsubstantiate
												.println("No company name provided.");
									} else {
										Connection con = null;
										try {
											Class.forName("com.mysql.jdbc.Driver");
											con = DriverManager.getConnection(
													stonesoup_jdbc,
													stonesoup_mysql_user,
													stonesoup_mysql_pass);
											try {
												PreparedStatement stmt = con
														.prepareStatement("INSERT INTO Shippers (CompanyName, Phone) VALUES (?, ?)");
												Tracer.tracepointMessage("CROSSOVER-POINT: BEFORE");
												stmt.setString(
														1,
														bemurmur_unfeasible
																.getmascally_workmanliness());
												stmt.setNull(2, Types.NULL);
												Tracer.tracepointMessage("CROSSOVER-POINT: AFTER");
												Tracer.tracepointMessage("TRIGGER-POINT: BEFORE");
												if (stmt.executeUpdate() > 0) {
													BlockListImpl.humplessInsubstantiate
															.println("Shipper added successfully.");
												} else {
													BlockListImpl.humplessInsubstantiate
															.println("No rows added.");
												}
												Tracer.tracepointMessage("TRIGGER-POINT: AFTER");
											} catch (SQLException se) {
												Tracer.tracepointError("SQLException: Printing connection details");
												BlockListImpl.humplessInsubstantiate
														.println("Database Error!");
												BlockListImpl.humplessInsubstantiate
														.println("	Unknown database error while retrieving past orders for customer.");
												BlockListImpl.humplessInsubstantiate
														.println("");
												BlockListImpl.humplessInsubstantiate
														.println("Connection Details");
												BlockListImpl.humplessInsubstantiate
														.printf("    Host: %s\n",
																stonesoup_mysql_host);
												BlockListImpl.humplessInsubstantiate
														.printf("    Port: %s\n",
																stonesoup_mysql_port);
												BlockListImpl.humplessInsubstantiate
														.printf("    User: %s\n",
																stonesoup_mysql_user);
												BlockListImpl.humplessInsubstantiate
														.printf("    Pass: %s\n",
																stonesoup_mysql_pass);
												BlockListImpl.humplessInsubstantiate
														.printf("    JDBC: %s\n",
																stonesoup_jdbc);
												BlockListImpl.humplessInsubstantiate
														.println("");
												BlockListImpl.humplessInsubstantiate
														.println("Error Message");
												BlockListImpl.humplessInsubstantiate
														.println(se
																.getMessage());
												BlockListImpl.humplessInsubstantiate
														.println("");
												BlockListImpl.humplessInsubstantiate
														.println("Stacktrace");
												se.printStackTrace(BlockListImpl.humplessInsubstantiate);
											}
										} catch (SQLException se) {
											Tracer.tracepointError(se
													.getClass().getName()
													+ ": " + se.getMessage());
											BlockListImpl.humplessInsubstantiate
													.println("STONESOUP: Failed to connect to DB.");
											se.printStackTrace(BlockListImpl.humplessInsubstantiate);
										} catch (ClassNotFoundException cnfe) {
											Tracer.tracepointError(cnfe
													.getClass().getName()
													+ ": " + cnfe.getMessage());
											BlockListImpl.humplessInsubstantiate
													.println("STONESOUP: Failed to load DB driver.");
											cnfe.printStackTrace(BlockListImpl.humplessInsubstantiate);
										} finally {
											try {
												if (con != null
														&& !con.isClosed()) {
													con.close();
												}
											} catch (SQLException e) {
												Tracer.tracepointError(e
														.getClass().getName()
														+ ": " + e.getMessage());
												BlockListImpl.humplessInsubstantiate
														.println("STONESOUP: Failed to close DB connection.");
												e.printStackTrace(BlockListImpl.humplessInsubstantiate);
											}
										}
									}
								}
								Tracer.tracepointWeaknessEnd();
							}
						}
					} finally {
						BlockListImpl.humplessInsubstantiate.close();
					}
				}
			}
		}
		ListManagedBlock result = null;

        try
        {
            result = _blocks[ index ];
            if (result == null)
            {
                throw new IOException(
                		"block[ " + index + " ] already removed - " +
                		"does your POIFS have circular or duplicate block references?"
                );
            }
            _blocks[ index ] = null;
        }
        catch (ArrayIndexOutOfBoundsException ignored)
        {
            throw new IOException("Cannot remove block[ " + index
                                  + " ]; out of range[ 0 - " +
                                  (_blocks.length-1) + " ]");
        }
        return result;
    }

    /**
     * get the blocks making up a particular stream in the list. The
     * blocks are removed from the list.
     *
     * @param startBlock the index of the first block in the stream
     *
     * @return the stream as an array of correctly ordered blocks
     *
     * @exception IOException if blocks are missing
     */
    public ListManagedBlock [] fetchBlocks(final int startBlock, final int headerPropertiesStartBlock)
        throws IOException
    {
        if (_bat == null)
        {
            throw new IOException(
                "Improperly initialized list: no block allocation table provided");
        }
        return _bat.fetchBlocks(startBlock, headerPropertiesStartBlock, this);
    }

    /**
     * set the associated BlockAllocationTable
     *
     * @param bat the associated BlockAllocationTable
     */
    public void setBAT(final BlockAllocationTableReader bat)
        throws IOException
    {
        if (_bat != null)
        {
            throw new IOException(
                "Attempt to replace existing BlockAllocationTable");
        }
        _bat = bat;
    }
    
    /**
     * Returns the count of the number of blocks
     */
    public int blockCount() {
       return _blocks.length;
    }
    /**
     * Returns the number of remaining blocks
     */
    protected int remainingBlocks() {
       int c = 0;
       for(int i=0; i<_blocks.length; i++) {
          if(_blocks[i] != null) c++;
       }
       return c;
    }
}
